/////////////////////////////////////////////////////////////////////////////
// CricCrac.h
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2001 Cricri  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on More FTC & Azertix 9c Those portions are
// Copyright Gloup & Azertix (C) 1999/2000 
//
/////////////////////////////////////////////////////////////////////////////

#include <windows.h>
#include <stdio.h> // utilisation de sprintf
#include "resource.h"
#include "../pluginvideo.h"

// ! must be equal to Resource Version
#define CRICRACK_VERSION		"0830"

// base shift for resolution of 754
#define     SHIFT_0             0
#define     SHIFT_1             13
#define     SHIFT_2             26

// base data bits position of the special lines for rsolution of 768
// thanks to Azertix !
#define     POS_BIT7           725
#define     POS_BIT6           636
#define     POS_BIT5           547
#define     POS_BIT4           458
#define     POS_BIT3           369
#define     POS_BIT2           280
#define     POS_BIT1           191
#define     POS_BIT0           102


#define		MAX_DIFF			3
#define		MAXLINE				((short)288)
#define		MAXPIXEL			((short)768)
#define		NBR_CONTRAST		3

#define		NOK					-1
#define		OK					0

#define		MAX_FCT_MODE		2
#define		MAX_DEC_MODE		5		
//#define		MAX_SHIFT_CRL		6		


typedef struct _YUY2_T {
	BYTE y0;
	BYTE cb;
	BYTE y1;
	BYTE cr;
} YUY2_T;

typedef struct _YUY_T {
	BYTE yX;
	BYTE cX;
} YUY_T;

typedef struct _LINE_T {
	union {
//		YUY2_T	*psLine2pt;
		YUY_T	*psYuy;
//		u_int	*punYuy2;
//        __int64 *plunYuy2;
		short	*pwYuy;
	};
	int		nSum1;
	int		nSum2;
	int		nSum3;
	int		nDiff[MAX_FCT_MODE][MAX_DEC_MODE];
	int		nShiftIdx[MAX_FCT_MODE][MAX_DEC_MODE];
	int		nShiftIdxKey;
} LINE_T, *PLINE_T;


#define	B_TT				0
#define	B_TE				1

#define	SZ_FCT_TT			"TT"
#define	SZ_FCT_TE			"TE"
#define SZ_FCT_AUTO			"AUTO"

typedef enum FCT_T {		// important order and values
	FCT_TT			= 1 << B_TT,		// 1 << 0
	FCT_TE			= 1 << B_TE,			// 1 << 1
	FCT_AUTO		= FCT_TT | FCT_TE	// FCT_AUTO = FCT_TT | FCT_TE
};


#define	B_DEC_CR			0
#define	B_DEC_CR_CORPC		1
#define	B_DEC_CR_CORP		2
#define	B_DEC_AZ			3
#define	B_DEC_AZ_START		4

#define	SZ_DEC_CR			"CRICRI"
#define	SZ_DEC_CR_CORPC		"CRICRI COR+"
#define	SZ_DEC_CR_CORP		"CRICRI COR+ CRL"
#define	SZ_DEC_AZ			"AZERTIX"
#define	SZ_DEC_AZ_START		"AZERTIX START"
#define SZ_DEC_AUTO			"AUTO"

typedef enum DEC_T {
	DEC_CR			= 1 << B_DEC_CR,
	DEC_CR_CORP		= 1 << B_DEC_CR_CORP,
	DEC_CR_CORPC	= 1 << B_DEC_CR_CORPC,
	DEC_AZ			= 1 << B_DEC_AZ,
	DEC_AZ_START	= 1 << B_DEC_AZ_START,
	DEC_AUTO		= DEC_CR | DEC_CR_CORPC | DEC_AZ
};

/*
typedef enum DET_STATE {
	DET_INIT = 0,
//	DET_START,
//	DET_RT,
//	DET_RTT,
	DET_RUNNING
};
*/

typedef struct _CMD_T {
	bool	bFreeze;
	bool	bSave;
	bool	bLoad;
	bool	bSaveOEInfos;
	bool	bSaveDecInfos;
	bool	bDisableFtcKey;
	FCT_T	eModeFct;
	DEC_T	eModeDec;
	bool	bMatrix;	// test zoom bas de lignes
} CMD_T;


typedef struct _STATUS_T {	// debug purpose for instance
	bool	bFrozen;
//	bool	bOpt1;
//	bool	bOpt2;
//	bool	bOpt3;
//	bool	bOpt4;
	bool	bOpt5;
	bool	bOpt6;
	bool	bOpt7;
	bool	bOpt8;
	bool	bOpt9;
	int		nNbrPt;
} STATUS_T;


typedef enum CHANNEL_STATE {	// important order and values
	CH_FTC_P = 0,				// Planete, RTL9, TV5, ...
	CH_FTC_E = 1,				// Euronews
	CH_FTC_J = 2,				// canal J, Rai
	CH_FTC_C = 3,				// cine Cinema
	CH_CANAL_PLUS_B = 4,
	CH_INIT,
	CH_RESEARCH
};

#define MAX_FTC_CHANNELS		4
#define NBR_CRYPTED_CHANNELS	5


typedef struct _POLY_T {
	int				nSeq;		// channel sequence detection
	int				nMask;		// sequence mask
	int				nNbrFrame;	// number of frames for the sequence
	int				nKey;		// start key for polynom
	int				nStartInc;	// start increment between frames
} POLY_T, *PPOLY_T;


typedef struct _KEY_T {
	CHANNEL_STATE	eChannel;	// channel type
	bool			bSync;		// top synchro to initialize the polynom
	POLY_T			sPoly[4];	// polynoms infos
} KEY_T;


typedef struct _FTC_CRACK {
	int			nY;
	int			nOffsetX;
	int			nCorBlackP;
	int			nCorBlackM;
	int			nCorPlus;
	int			nCorMoins;
	int			nLevel;
	int			nLumLevelAdd;
	int			nLumLevel;
	int			nSumBlackLevel;
	int			nSumBlackTreshold;
	int			n3SumBlackTresholdM;
	int			n3SumBlackTresholdP;
	LINE_T		tsLE[2][MAXLINE];
	LINE_T		tsLO[2][MAXLINE];
	int			nDecChoosen[2];
	int			nFctChoosen[2];
	int			nCurPicture;
	int			nRefYE;
	int			nRefY0;
	short		wtFrameBufE[MAXLINE][MAXPIXEL];
	short		wtFrameBufO[MAXLINE][MAXPIXEL];
	int			nSumR;
	u_long		ntContCrl[MAX_DIFF];
	u_long		ntStartCrl[MAX_DIFF];
	STATUS_T	sStatus;
	CMD_T		sCmd;
	int			nYmin;
	int			nYmax;
	int			nErr[MAX_FCT_MODE][MAX_DEC_MODE];
	int			nErrMin;
	char		szFct[32];
	char		szDec[32];
	int			nCurModeFct;
	int			nCurModeDec;
	bool		bKeyMode;
	BOOL		bSignalDetecte;
	char		szVersion[8];
	KEY_T		sKey;
	int			nPrevFrame;
} FTC_CRACK, *PFTC_CRACK;


