/////////////////////////////////////////////////////////////////////////////
// CriCrack.cpp	:	main part
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2001 Cricri  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on More FTC & Azertix 9c Those portions are
// Copyright Gloup & Azertix (C) 1999/2000 
//
/////////////////////////////////////////////////////////////////////////////
// [~ 02/11/2001 ~] Add interlace trame working mode
// [~ 20/12/2001 ~] Add automatic detection for working mode
// [~ 02/01/2002 ~] Add automatic detection of multi-decrypt mode
// [~ 03/01/2002 ~] Correlation per repartition optimisation for multi-decrypt
//					mode : memorize correlation & look for correlations already
//					done, gain 15-20% !
// [~ 05/01/2002 ~] Code reorganisation ... still todo
// [~ 06/01/2002 ~] Optimisation of automatic working mode : if no correlation
//					error, don't execute trame per trame working mode
// [~ 12/01/2002 ~] Add level adjustement and compatibility with K!TV 1012
// [~ 13/01/2002 ~] Add coded channel automatic detection
// [~ 20/01/2002 ~] Add coded channel automatic detection for C+B
// [~ 03/02/2002 ~] Adaptation to new K!TV structure and working mode
// [~ 07/02/2002 ~] correction of TE mode ...
// [~ 09/02/2002 ~] chrominance adjustement correction/modification
// [~ 10/02/2002 ~] cleaning code, removing unused options
// [~ 10/02/2002 ~] Update to K!TV 1100
// [~ 10/02/2002 ~] Crypted channel detection modification
// [~ 18/02/2002 ~] Crypted channel detection correction for C+B
// [~ 19/02/2002 ~] Add VIA options
// [~ 19/02/2002 ~] Correction freeze/copy mode, did not work with K!TV 1100
// [~ 20/02/2002 ~] Add Ok/Cancel/Default options, BDD reorganisation
// [~ 20/02/2002 ~] Add Version string in INI file to erase old values
// [~ 20/02/2002 ~] Add macro for version and Intel / Vcc distinction
// [~ 20/02/2002 ~] Add key CTRL F9 for plugin options call
// [~ 20/02/2002 ~] Add VIA_FIX & VIA_FIX_X options saved in CricCrac
//					INI because K!TV INI does not handle them ...
// [~ 21/02/2002 ~] "About" box update and version management
// [~ 21/02/2002 ~] Add message for incorrect value of X Capture
// [~ 22/02/2002 ~] INI file erased when version changes
// [~ 24/02/2002 ~] Key mode implementation
// [~ 24/02/2002 ~] detection modification for key mode and robustification
// [~ 24/02/2002 ~] Add display key mode 
// [~ 24/02/2002 ~] New name : CriCrack ... 
// [~ 10/03/2002 ~] Add call to plugin help 
// [~ 14/03/2002 ~] Euronews detection correction 
// [~ 21/03/2002 ~] correction memo infos shifts C+Br, debug purpose 
// [~ 02/04/2002 ~] correction OSD management 



#include "CriCrack.h"

//#include "../../K!TV-XP/externe/HtmlHelp.H"

#ifdef	_USE_INTEL_COMPILER
	#define COMPILO		" intel "
#else
	#define	COMPILO		" vcc "
#endif

#define CRICRACK_DESCRIPTION	"CriCrack " \
								CRICRACK_VERSION \
extern char PluginINI[];

// Cration d'une instance de l'objet de type KTV_VideoPlugin
QuenotteTV_VideoPlugin sVP;

// CriCrack general context
FTC_CRACK	sCtx;

CRITICAL_SECTION	sCS;

int		ntShift[] = { 0, 13, 26};

								COMPILO \
								"(Cricri)"


// CriCrack general context

/*
ACCEL AccTable[] = {
	{ VK_SHIFT,'f',ID_FREEZEFRAME},	// SHIFT F 
	{ VK_SHIFT,'l',ID_LOADFRAME},	// SHIFT L
	{ VK_SHIFT,'s',ID_SAVEFRAME},	// SHIFT S
	{ VK_CONTROL,VK_F1+'a'- 65,ID_OPT1},	// display special lines
	{ VK_CONTROL,VK_F2+'a'- 65,ID_OPT2},	// save infos O286 & E287
	{ VK_CONTROL,VK_F3+'a'- 65,ID_OPT3},	// save shifts
	{ VK_CONTROL,VK_F4+'a'- 65,ID_OPT4},	// not used yet
	{ VK_CONTROL,VK_F5+'a'- 65,ID_OPT5},	// not used yet
	{ VK_CONTROL,VK_F6+'a'- 65,ID_OPT6},	// not used yet
	{ VK_CONTROL,VK_F7+'a'- 65,ID_OPT7},	// not used yet
	{ VK_CONTROL,VK_F8+'a'- 65,ID_OPT8},	// not used yet
	{ VK_CONTROL,VK_F9+'a'- 65,ID_OPT9}		// Adjustement dialog call
};
*/


/* test purpose, algorithmic method	*/
#define MAX_TAB_DEC		576 * 6
static int	nTabDec[MAX_TAB_DEC];


/* ---------------------- Internal Functions declaration ------------------- */

static void cr_init();
static void cr_prepareUpdateScreen( BOOL bIsOdd);

static BOOL __cdecl cr_start();
static BOOL __cdecl cr_stop();
static void __cdecl cr_showDialog();

static void __cdecl cr_initStuff();
static void __cdecl cr_doStuff( BOOL bIsOdd, BOOL *bUpdateBuffer, BOOL *bViewBuffer);
static void __cdecl cr_checkStuff( void);	

static void __cdecl cr_getStatus( char *szText, BOOL bNB);
static BOOL __cdecl cr_processMessage( UINT message, UINT wParam,
									  LONG lParam, char *OSDDisplay);
static void __cdecl cr_updateMenu( HMENU hMenu, HINSTANCE hInst,
								  BOOL ContextMenu);
static void __cdecl cr_setLow( unsigned char bBrightness);
static BOOL __cdecl cr_autoMovieBoostFound();
static BOOL __cdecl cr_detecteSignal( BYTE *VBI);



/* ---------------------- External Functions declaration ------------------- */

BOOL misc_load_INI();
BOOL misc_write_INI();

BOOL APIENTRY bdd_setup_proc( HWND hDlg,
							  UINT message,
							  UINT wParam,
							  LONG lParam);

bool misc_save_frame( void);
bool misc_load_frame( void);
bool misc_copy_frame( const BOOL bIsOdd);
bool misc_freeze_frame(void);


inline int dec_sum_lum( YUY_T *const pSrce, const int nPix);
//int dec_shift( short *const pDest, short *const pSrce, const int nShift);
inline void dec_shift_cr( YUY_T *const pPixel, const int nShift);
void misc_search_blackband( YUY_T *const pSrce, const int y);
int dec_mark( short *const pDest, const int nShift, const int nVal);
int dec_main( LINE_T *const psLine, LINE_T *const psRef, const int y);
//bool misc_IsCodedChannel( YUY_T **const ptLinesOrgE, YUY_T **const ptLinesOrgO);
bool misc_IsCodedChannel( YUY_T **const ptLinesOrgE, YUY_T **const ptLinesOrgO,
						 const int nFrame);
void misc_load_def( void);
int dec_key( LINE_T *const psLine);

/* ------------------------------------------------------------------------- */



/* ------------------------------- Dll call -------------------------------- */
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
/* ------------------------------------------------------------------------- */
{
    switch ( ul_reason_for_call) {

		case DLL_PROCESS_ATTACH:
			InitializeCriticalSection( &sCS);
			if ( !misc_load_INI()) {
				DeleteFile( PluginINI);
				misc_load_def();
			}
			break;
		case DLL_THREAD_ATTACH:
			break;
		case DLL_THREAD_DETACH:
			break;
		case DLL_PROCESS_DETACH:
			misc_write_INI();
			DeleteCriticalSection( &sCS);
			break;
    }
    return TRUE;

	/* to avoid warning	*/
	UNREFERENCED_PARAMETER( hModule);
	UNREFERENCED_PARAMETER( lpReserved);

}




/* ---------------- Dclaration de cette instance  K!TV ------------------- */
extern "C" __declspec( dllexport )QuenotteTV_VideoPlugin * GetVPlugin()
/* ------------------------------------------------------------------------- */
{
	
	sVP.description = CRICRACK_DESCRIPTION;
	sVP.version = VIDEO_PLUGIN_VERSION;
	sVP.MovieBoost = 0;
	sVP.accel = &AccTable[0];
	sVP.NbAccel = sizeof(AccTable) / sizeof(AccTable[0]);

	sVP.Start = cr_start;
	sVP.Stop = cr_stop;
	sVP.ShowDialog = cr_showDialog;

	sVP.InitStuff = cr_initStuff;
	sVP.DoStuff = cr_doStuff;
	sVP.CheckStuff = cr_checkStuff;

	sVP.GetStatus = cr_getStatus;
	sVP.ProcessMessage = cr_processMessage;
	sVP.UpdateMenu = cr_updateMenu;
	sVP.SetLow = cr_setLow;
	sVP.AutoMovieBoostFound = cr_autoMovieBoostFound;
	sVP.DetecteSignal = cr_detecteSignal;

	cr_init();
	
	return( &sVP);
}

/* --------------------------- Init Plugin --------------------------------- */
static void cr_init()
/* ------------------------------------------------------------------------- */
{		
	
	sCtx.nY = MAXLINE;
	sCtx.bSignalDetecte = FALSE;
	sCtx.sKey.eChannel = CH_INIT;
	sCtx.bKeyMode = false;

}



/* ----- appele quand on appuie sur F3 renvoie false si a marche pas ----- */
static BOOL cr_start()
/* ------------------------------------------------------------------------- */
{		
	EnterCriticalSection( &sCS);

	sCtx.nCurPicture = 0;
	
	LeaveCriticalSection( &sCS);
	
	return( TRUE);
}



/* ------------- appele  la fin renvoie false si a marche pas ----------- */
static BOOL cr_stop()
/* ------------------------------------------------------------------------- */
{
	EnterCriticalSection( &sCS);
	
	sCtx.sStatus.bFrozen = false;
	sCtx.sKey.eChannel = CH_INIT;
	sCtx.bKeyMode = false;
	
	LeaveCriticalSection( &sCS);

	return( TRUE);
}



/* ------------------ Dialog box : pour changer les options ---------------- */
static void cr_showDialog()
/* ------------------------------------------------------------------------- */
{
	DialogBox( sVP.hDllInstance, "PARAMETER", sVP.hwndParent, bdd_setup_proc);
}



/* ----------------------- Lanc juste aprs cr_start ---------------------- */
static void cr_initStuff()
/* ------------------------------------------------------------------------- */
{	
//	sCtx.n3SumBlackTresholdM = sCtx.n3SumBlackTresholdP = SUM_MIN3;
	if ( !sVP.FullField)	//	not initialized in start()
		sCtx.sCmd.eModeFct = FCT_TT;

}		



/* ---------------------- comme son nom l'indique ... ---------------------- */
static void cr_doStuff( BOOL bIsOdd, BOOL *bUpdateBuffer, BOOL *bViewBuffer)
/* ------------------------------------------------------------------------- */
{
	static short	**ppLines;
	static YUY_T	*psCurLine;
	static int		n2SumMaxLum, nSumMinLum, n2SumLum;
	static int		y, j, *pnRefY, *pnRefYE, nMaxX, nMaxY, nMinY;
	static PLINE_T	ptsLine, ptsLineE;


	EnterCriticalSection( &sCS);

#ifdef _DEBUG
	__try {
#endif

	if ( bIsOdd) {
		ppLines = sVP.OddLines[sVP.CurrentFrame];
		ptsLine = sCtx.tsLO[sCtx.nCurPicture];
		pnRefY = &sCtx.nRefY0;
	} else {
		ppLines = sVP.EvenLines[sVP.CurrentFrame];
		ptsLine = sCtx.tsLE[sCtx.nCurPicture];
		pnRefY = &sCtx.nRefYE;
	}

	/* freeze, save, load frame management; debug purpose	*/
	if ( sCtx.sStatus.bFrozen) {
		misc_copy_frame( bIsOdd);
	}
	if ( sCtx.sCmd.bFreeze && bIsOdd) {
		sCtx.sStatus.bFrozen = misc_freeze_frame();
		sCtx.sCmd.bFreeze = false;
	}
	if ( sCtx.sCmd.bSave && bIsOdd) {
		misc_save_frame();
		sCtx.sCmd.bSave = false;
	}

	/* key mode	*/
	if ( sCtx.bKeyMode) {
		dec_key( ptsLine);
		goto Update;
	}

	/* init	*/
	*pnRefY = n2SumMaxLum = -1;
	nSumMinLum = 1000000;
	sCtx.nErrMin = 300;
	ZeroMemory( ptsLine, sizeof(LINE_T) * MAXLINE);
	ZeroMemory( sCtx.nErr, sizeof(int) * MAX_FCT_MODE * MAX_DEC_MODE);

	/* search max luminance line as ref line and min luminance	*/
	nMaxY = sCtx.nY - sVP.MovieBoost - 1; // TODO remove -2 when boost will work
	nMinY = 1 + sVP.MovieBoost;

	for ( y = 0; y < sCtx.nY; y++) {
		
		/* Current Frame	*/
		psCurLine = (YUY_T *)ppLines[y];

		ptsLine[y].psYuy = psCurLine;
		ptsLine[y].nSum1 = dec_sum_lum( psCurLine, ntShift[1]);
		ptsLine[y].nSum2 = dec_sum_lum( &psCurLine[ntShift[1]], ntShift[1]);
		ptsLine[y].nSum3 = dec_sum_lum( &psCurLine[ntShift[2]], ntShift[1]);
		
		n2SumLum = ptsLine[y].nSum1 + ptsLine[y].nSum2;
		

		if ( n2SumLum > n2SumMaxLum && y > nMinY && y < nMaxY) {
			n2SumMaxLum = n2SumLum;
			*pnRefY = y;
		} else if ( ptsLine[y].nSum1 < nSumMinLum && y < nMaxY) {
			nSumMinLum = ptsLine[y].nSum1;
		}

		/* search for min lum band	*/
		misc_search_blackband( psCurLine, y);
	}

	/*	calculate min luminance level	*/
	sCtx.nSumBlackLevel = nSumMinLum;
	sCtx.nSumBlackTreshold = sCtx.nSumBlackLevel + ( sCtx.nSumBlackLevel >> 1);
	sCtx.nLevel = sCtx.nSumBlackLevel / ntShift[1];
	sCtx.nLumLevel = sCtx.nLevel + sCtx.nLumLevelAdd;

	if ( n2SumMaxLum < sCtx.nSumBlackTreshold) // if MaxLumY not correct
		*pnRefY = sVP.MovieBoost; // then use minY as reference line

	/* Shift 0 for even reference line for all methods	*/
	ZeroMemory( ptsLine[*pnRefY].nShiftIdx,
				MAX_FCT_MODE * MAX_DEC_MODE * sizeof(int));

	dec_mark( ptsLine[*pnRefY].pwYuy,	// for debug
				ntShift[2],
				0xFFFF);


	/* Interlace trame working mode, better when no much movement	*/
	if ( sCtx.sCmd.eModeFct & FCT_TE && bIsOdd) {
		 
		sCtx.nCurModeFct = B_TE;
		ptsLineE = sCtx.tsLE[sCtx.nCurPicture];

		/* from reference line up to line 1	*/
		for ( y = sCtx.nRefYE - 1; y > sVP.MovieBoost; y--) {
			/* decode odd frame	if it is not the ref line	*/
			if ( y != *pnRefY) {
				dec_main( &ptsLine[y], &ptsLineE[y + 1], y);
			}
			/* decode even frame	*/
			dec_main( &ptsLineE[y], &ptsLine[y], y);
		}
		/* from reference line down to line 288	*/
		for ( y = sCtx.nRefYE; y < nMaxY; y++) {
			/* decode odd frame	if it is not the ref line	*/
			if ( y != *pnRefY) {
				dec_main( &ptsLine[y], &ptsLineE[y], y);
			}
			/* decode even frame	*/
			dec_main( &ptsLineE[y + 1], &ptsLine[y], y + 1);
		}

		/*	search best method ( less correlation errors ) in TE working mode */
		for ( j = 0; j < MAX_DEC_MODE; j++) {
		
			/* interlaced trame method	*/
			if ( sCtx.sCmd.eModeDec & (1 << j)
				&& sCtx.nErr[B_TE][j] < sCtx.nErrMin) {

				sCtx.nErrMin = sCtx.nErr[B_TE][j];
				sCtx.nDecChoosen[sCtx.nCurPicture] = j;
				sCtx.nFctChoosen[sCtx.nCurPicture] = B_TE;
			}
		}
	}

	/* Trame per trame working mode, better when there is movement	*/
	if ( sCtx.nErrMin != 0 && sCtx.sCmd.eModeFct & FCT_TT) {

		sCtx.nCurModeFct = B_TT;

		/* from reference line up to line 1	*/
		for ( y = *pnRefY - 1; y > sVP.MovieBoost; y--) {
			dec_main( &ptsLine[y], &ptsLine[y + 1], y);
		}
		/* from reference line down to line 288	*/
		for ( y = *pnRefY + 1; y < sCtx.nY - sVP.MovieBoost; y++) {
			dec_main( &ptsLine[y], &ptsLine[y - 1], y);
		}

		/* search only if FF && odd or HF && even	*/
		if ( !( bIsOdd ^ sVP.FullField)) {
			/*	search best method ( less correlation errors )	*/
			for ( j = 0; j < MAX_DEC_MODE; j++) {
		
				/* trame per trame method, interlaced already done	*/
				if ( sCtx.sCmd.eModeDec & (1 << j)
					&& sCtx.nErr[B_TT][j] < sCtx.nErrMin) {
		
					sCtx.nErrMin = sCtx.nErr[B_TT][j];
					sCtx.nDecChoosen[sCtx.nCurPicture] = j;
					sCtx.nFctChoosen[sCtx.nCurPicture] = B_TT;
				}
			}
		}
	}
	
Update:

	cr_prepareUpdateScreen( bIsOdd);

	if ( sVP.FullField && bIsOdd) {
		*bUpdateBuffer = TRUE;
		*bViewBuffer = TRUE;
	} else if ( sVP.FullField && !bIsOdd) {
		*bUpdateBuffer = TRUE;
		*bViewBuffer = FALSE;
	} else if ( !sVP.FullField && bIsOdd) {
		*bUpdateBuffer = FALSE;
		*bViewBuffer = FALSE;
	} else if ( !sVP.FullField && !bIsOdd) {
		*bUpdateBuffer = TRUE;
		*bViewBuffer = TRUE;
	}


	/* prepare next picture index for internal buffer	*/
	if ( bIsOdd) {
		sCtx.nCurPicture = sCtx.nCurPicture ? 0 : 1;
	}

#ifdef _DEBUG
	}
    __except( EXCEPTION_EXECUTE_HANDLER) {
		OutputDebugString( "Crash in doStuff\n");
	}
#endif

	LeaveCriticalSection( &sCS);

}



/* ------------------------------------------------------------------------- */
static void save_dec( int pTab[], const int nNbr)
/* ------------------------------------------------------------------------- */
{
	FILE	*pFh;

	
	if ( (pFh = fopen( "_DecInfos.txt","w+b")) == NULL)
		return;

	for ( int j = 0; j < nNbr; j ++) {
		fwrite( &pTab[j], sizeof(char), 1, pFh);
//		fprintf( pFh, "%d\n", pTab[j]);
	}

	fclose( pFh);
	pFh = NULL;

	return;
}



/* --------------- Choisissons l'ordre de sortie les lignes ---------------- */
void cr_prepareUpdateScreen( BOOL bIsOdd)
/* ------------------------------------------------------------------------- */
{
	static int		y, j, nShiftIdx, nDelta, nSaveIdx = 0;
	static int		nSrcePic, nSrceFrame, nDec, nFct;
	static short	**pD, **pS;
	static PLINE_T	ptsLine;


#ifdef _DEBUG
	__try {
#endif

	/*	Init Key mode	*/
	if ( sCtx.bKeyMode) {
		nSrcePic = sCtx.nCurPicture;
		nSrceFrame = sVP.CurrentFrame;
	/*	Init STD mode : display previous picture	*/
	} else {
		nSrcePic = sCtx.nCurPicture ? 0 : 1;
		nSrceFrame = sVP.CurrentFrame == 0 ? 4 : sVP.CurrentFrame - 1;
		nDec = sCtx.nDecChoosen[nSrcePic];
		nFct = sCtx.nFctChoosen[nSrcePic];
	}

	if ( bIsOdd) {
		pD = sVP.OutOddLines[sVP.CurrentFrame];
		pS = sVP.OddLines[nSrceFrame];
		ptsLine = sCtx.tsLO[nSrcePic];
	} else {
		pD = sVP.OutEvenLines[sVP.CurrentFrame];
		pS = sVP.EvenLines[nSrceFrame];
		ptsLine = sCtx.tsLE[nSrcePic];
	}

	/*	debug purpose, display some lines	*/
	if ( sCtx.sCmd.bMatrix) {
		for ( y = 0; y < sCtx.nY; y++) {
			if ( y > 10 && y < 21) {
				/* display	E0	*/
				pD[y] = sVP.EvenLines[sVP.CurrentFrame][0];
			} else if ( y > 30 && y < 41) {
				/* display	E1	*/
				pD[y] = sVP.EvenLines[sVP.CurrentFrame][1];
			} else if ( y > 50 && y < 61) {
				/* display	E286	*/
				pD[y] = sVP.EvenLines[sVP.CurrentFrame][286];
			} else if ( y > 70 && y < 81) {
				/* display	E287	*/
				pD[y] = sVP.EvenLines[sVP.CurrentFrame][287];
			} else if ( y > 90 && y < 101) {
				/* display	O0	*/
				pD[y] = sVP.OddLines[sVP.CurrentFrame][0];
			} else if ( y > 110 && y < 121) {
				/* display	O1	*/
				pD[y] = sVP.OddLines[sVP.CurrentFrame][1];
			} else if ( y > 130 && y < 141) {
				/* display	O286	*/
				pD[y] = sVP.OddLines[sVP.CurrentFrame][286];
			} else if ( y > 150 && y < 161) {
				/* display	O287	*/
				pD[y] = sVP.OddLines[sVP.CurrentFrame][287];
			} else {
				/* normal	*/
				pD[y] = pS[y];
			}
		}
		return;
	}

	/* apply shifts				*/
	for ( y = 0; y < sCtx.nY; y++) {

		/* choice between standard and key mode	*/
		if ( sCtx.bKeyMode) {
			nShiftIdx = ptsLine[y].nShiftIdxKey;
			nDelta = ntShift[nShiftIdx & 3] + sCtx.nOffsetX;
			pD[y] = pS[y] + nDelta;
		} else {

			nShiftIdx = ptsLine[y].nShiftIdx[nFct][nDec];
		
			if ( (nShiftIdx & 3) > 2)	// debug should not happen
				nShiftIdx = 0;

			nDelta = ntShift[nShiftIdx & 3] + sCtx.nOffsetX;
			pD[y] = pS[y] + nDelta;
		}

		/*	apply chrominance correction for odd shifts	*/
		if ( nDelta & 1)
			dec_shift_cr( (YUY_T *)pD[y], nDelta);

		/*	debug : mark end of line correlation problem	*/
		if ( nShiftIdx < 0) {
			dec_mark( pD[y], ntShift[2], 0x00FF);
//		} else {
//			dec_mark( pD[y], ntShift[2], 0x2020);
		}

		/* Save Shift Idx  frame	*/
		if ( sCtx.sCmd.bSaveDecInfos
			&& ((sCtx.sKey.bSync == 1 && bIsOdd) || nSaveIdx > 0)
			&& nSaveIdx < MAX_TAB_DEC) {

			nShiftIdx = ptsLine[y].nShiftIdx[nFct][nDec];
//			nShiftIdx = ptsLine[y].nShiftIdxKey;

			nTabDec[nSaveIdx++] = nShiftIdx & 3;
			sCtx.sCmd.bSaveOEInfos = true;
		}
	}

	/* test	*/
	if ( sCtx.sCmd.bSaveDecInfos && nSaveIdx >= MAX_TAB_DEC) {
		sCtx.sKey.bSync = false;
		sCtx.sCmd.bSaveDecInfos = false;
		nSaveIdx = 0;
		save_dec( nTabDec, MAX_TAB_DEC);
	}

#ifdef _DEBUG
	}
    __except( EXCEPTION_EXECUTE_HANDLER) {
		OutputDebugString( "Crash in updateBuffer\n");
	}
#endif

}	



/* -------------------------- Vrif quelconque ---------------------------- */
void cr_checkStuff( void)
/* ------------------------------------------------------------------------- */
{

}	



/* ------------- Affiche des trucs sur la barre des status ----------------- */
void cr_getStatus( char *szText, BOOL bNB)
/* ------------------------------------------------------------------------- */
{
	
	if ( szText == NULL)
		return;

	if ( bNB) {
		if ( sVP.CurrentX > 740) {
			sprintf( szText, "%s %d x %d", 
					(sVP.FullField == TRUE) ? "FF": "HF",
					sVP.CurrentX, sCtx.nY << 1);
		} else {
			sprintf( szText, "X trop faible ( optimal : 754)",
					sVP.CurrentX);
		}
	} else {
		if ( sCtx.bKeyMode) {
			sprintf( szText, "FTC by Key");
		} else {
			sprintf( szText, "Fct : %s Dec : %s",
					sCtx.szFct,	sCtx.szDec);
		}
	}
}



/* ------ Pour y envoyer les messages le concernant (raccoucis clavier) ---- */
BOOL cr_processMessage( UINT message, UINT wParam,
							    LONG lParam, char *OSDDisplay)
/* ------------------------------------------------------------------------- */
{
	BOOL	MessageProcessed = TRUE;


	switch ( message) {

	case WM_COMMAND	:

		switch ( LOWORD( wParam)) {

		case ID_FREEZEFRAME :

			/* if status frozen, stop freezing	*/
			if ( sCtx.sStatus.bFrozen) {
				sCtx.sStatus.bFrozen = false;
				sprintf( OSDDisplay, "Release Frame");
			/* otherwise cmd freeze	*/
			} else {
				sCtx.sCmd.bFreeze = true;
				sprintf( OSDDisplay, "Freeze Frame");
			}
			break;

		case ID_SAVEFRAME :

			sCtx.sCmd.bSave = true;
			sprintf( OSDDisplay, "Save Frame");
			break;

		case ID_LOADFRAME :

			sCtx.sStatus.bFrozen = misc_load_frame();
			break;

		case ID_OPT1 :

			sCtx.sCmd.bMatrix = !sCtx.sCmd.bMatrix;
			break;

		case ID_OPT2 :

			sCtx.sCmd.bSaveOEInfos = true;
			sprintf( OSDDisplay, "Save Lignes Infos");
			break;

		case ID_OPT3 :

			sCtx.sCmd.bSaveDecInfos = true;
			sprintf( OSDDisplay, "Save Shifts Infos");
			break;

		case ID_OPT4 :

			sCtx.sCmd.bDisableFtcKey = !sCtx.sCmd.bDisableFtcKey;
			sprintf( OSDDisplay, sCtx.sCmd.bDisableFtcKey
								? "Decrypt by Correlation"
								: "Decrypt by Key");
			break;

		case ID_OPT5 :
//			sprintf( OSDDisplay, "Non Gere");
			sCtx.sStatus.bOpt5 = !sCtx.sStatus.bOpt5;
			break;

		case ID_OPT6 :

//			sCtx.sStatus.bOpt6 = !sCtx.sStatus.bOpt6;
			break;

		case ID_OPT7 :

//			sCtx.sStatus.bOpt7 = !sCtx.sStatus.bOpt7;
			break;

		case ID_OPT8 :

//			sCtx.sStatus.bOpt8 = !sCtx.sStatus.bOpt8;
			break;

		case ID_OPT9 :

//			sCtx.sStatus.bOpt9 = !sCtx.sStatus.bOpt9;
			cr_showDialog();
			break;

		case IDM_HELP_PLUGIN: //Affichage de l'aide en ligne des plugins
            HtmlHelp( GetDesktopWindow(),
						"AidePlugin.chm::/0Plugin.htm",
						HH_DISPLAY_TOPIC,
						NULL);
			break;

		default :

			MessageProcessed = FALSE;
		}
		break;

	default :

		MessageProcessed = FALSE;
	}

	return( MessageProcessed);

	UNREFERENCED_PARAMETER( lParam);
//	UNREFERENCED_PARAMETER( OSDDisplay);

}



/* ---------------- Modifie le menu principal au lancement ----------------- */
void cr_updateMenu(HMENU hMenu, HINSTANCE hInst, BOOL ContextMenu)
/* ------------------------------------------------------------------------- */
{

	if ( ContextMenu) {
		InsertMenu( hMenu, 
					(unsigned int)GetSubMenu( hMenu, 4),
					MF_POPUP,
					(unsigned int)GetSubMenu( LoadMenu( hInst, "IDR_CRICRAC_MENU"),
											0),
					"&Dcodage");
	} else {
		ModifyMenu( GetSubMenu( hMenu, 3),
					2,
					MF_BYPOSITION | MF_POPUP,
					(unsigned int)GetSubMenu( LoadMenu( hInst, "IDR_CRICRAC_MENU"),
											0),
					"&Dcodage");
	}
}




/* ------------------------ Truc standard pas bien utile ------------------- */
void cr_setLow(unsigned char bBrightness)
/* ------------------------------------------------------------------------- */
{
	return;

	UNREFERENCED_PARAMETER( bBrightness);
	
}



/* --------------------- gestion des bandes noires ------------------------- */
BOOL cr_autoMovieBoostFound()
/* ------------------------------------------------------------------------- */
/*
	Accelere le truc en supprimant le haut et le bas Ce plugin devrai donc
	dtecter les ligne noires et s'il y en a, retourner true et changer la 
	valeur de sVP.MovieBoost
*/
{
//	not managed yet

	int i = 0;

//	i = 10;

	if ( i != sVP.MovieBoost) {
		sVP.MovieBoost = i;
		return( TRUE);
	}

	return( FALSE);
}



/* ------------------------------------------------------------------------- */
BOOL cr_detecteSignal( BYTE *VBI)
/* ------------------------------------------------------------------------- */
{
	static int	nPreviousFrame;

	
#ifdef _DEBUG
	__try {
#endif

	nPreviousFrame = sVP.CurrentFrame == 0 ? 4 : sVP.CurrentFrame - 1;

	/* check if channel is crypted, as this function is called on the first
		frame ( even ), use of last odd frame								*/
	sCtx.bSignalDetecte = misc_IsCodedChannel( 
									(YUY_T **)sVP.EvenLines[sVP.CurrentFrame],
									(YUY_T **)sVP.OddLines[nPreviousFrame],
									sVP.CurrentFrame);

#ifdef _DEBUG
	}
    __except( EXCEPTION_EXECUTE_HANDLER) {
		OutputDebugString( "Crash in detecteSignal\n");
	}
#endif

	return( sCtx.bSignalDetecte);

	UNREFERENCED_PARAMETER( VBI);

}

