/////////////////////////////////////////////////////////////////////////////
// Misc.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2001 Cricri  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on More FTC & Azertix 9c Those portions are
// Copyright Gloup & Azertix (C) 1999/2000 
//
/////////////////////////////////////////////////////////////////////////////

#include "CriCrack.h"


static int loadStringEx( HINSTANCE  hModule,    // handle to resource module
                         UINT       uID,        // resource identifier
                         LPTSTR     lpBuf,      // resource buffer
                         int        nBufMax,    // size of buffer
                         WORD       wLangID     // language identifier
);




/* ------------------------------------------------------------------------- */
void locale_Menu( HMENU         hMenu,          // handle to menu
                  HINSTANCE     hModule,        // handle to module ( Dll )
                  WORD          wLangID)        // language identifier
/* ------------------------------------------------------------------------- */
{
    #define         NBR_OF_SUBITEM  5
    
    MENUITEMINFO    sMenuItemInfo;
    static char     szStrMenu[NBR_OF_SUBITEM][40];
    int             j = 0;


    if ( wLangID != MAKELANGID( LANG_ENGLISH, SUBLANG_DEFAULT)) {
        sMenuItemInfo.cbSize = sizeof( MENUITEMINFO);
        sMenuItemInfo.fMask  = MIIM_TYPE;
        sMenuItemInfo.fType  = MFT_STRING;

            
        if ( loadStringEx( hModule,
                           IDS_PLUGIN_VIDEO_ON,
                           szStrMenu[j],
                           sizeof(szStrMenu[0]),
                           wLangID)) {
        
            sMenuItemInfo.dwTypeData = szStrMenu[j];
            SetMenuItemInfo( hMenu, IDM_PLUGIN_VIDEO_ON, FALSE, &sMenuItemInfo);
        }
        j++;
        
        if ( loadStringEx( hModule,
                           IDS_PLUGIN_VIDEO_OFF,
                           szStrMenu[j],
                           sizeof(szStrMenu[0]),
                           wLangID)) {
        
            sMenuItemInfo.dwTypeData = szStrMenu[j];
            SetMenuItemInfo( hMenu, IDM_PLUGIN_VIDEO_OFF, FALSE, &sMenuItemInfo);
        }
        j++;
        
        if ( loadStringEx( hModule,
                           IDS_PLUGIN_VIDEO_FORCE,
                           szStrMenu[j],
                           sizeof(szStrMenu[0]),
                           wLangID)) {
        
            sMenuItemInfo.dwTypeData = szStrMenu[j];
            SetMenuItemInfo( hMenu, IDM_PLUGIN_VIDEO_FORCE, FALSE, &sMenuItemInfo);
        }
        j++;
        
        if ( loadStringEx( hModule,
                           IDS_PLUGIN_VIDEO_SETUP,
                           szStrMenu[j],
                           sizeof(szStrMenu[0]),
                           wLangID)) {
        
            sMenuItemInfo.dwTypeData = szStrMenu[j];
            SetMenuItemInfo( hMenu, IDM_PLUGIN_VIDEO_SETUP, FALSE, &sMenuItemInfo);
        }
        j++;
        
        /* last ID not following the other  */
        if ( loadStringEx( hModule, 
                           IDS_HELP_PLUGIN,
                           szStrMenu[j],
                           sizeof(szStrMenu[0]),
                           wLangID)) {

            sMenuItemInfo.dwTypeData = szStrMenu[j];
            SetMenuItemInfo( hMenu, IDM_HELP_PLUGIN, FALSE, &sMenuItemInfo);
        }

    }
}



/* ------------------------------------------------------------------------- */
void locale_Menu1( HMENU         hMenu,          // handle to menu
                  HINSTANCE     hModule,        // handle to module ( Dll )
                  WORD          wLangID)        // language identifier
/* ------------------------------------------------------------------------- */
{
    #define         NBR_OF_SUBITEM  5
    
    MENUITEMINFO    sMenuItemInfo;
    static char     szStrMenu[NBR_OF_SUBITEM][32];
    u_int           j, uIDS = IDS_PLUGIN_VIDEO_ON, uIDM = IDM_PLUGIN_VIDEO_ON;


    if ( wLangID != MAKELANGID( LANG_ENGLISH, SUBLANG_DEFAULT)) {
        sMenuItemInfo.cbSize = sizeof( MENUITEMINFO);
        sMenuItemInfo.fMask  = MIIM_TYPE;
        sMenuItemInfo.fType  = MFT_STRING;

        /*  ID should be in increasing order */
        for ( j = 0; j < NBR_OF_SUBITEM - 1; j++) {
            
            if ( loadStringEx( hModule,
                               uIDS + j,
                               szStrMenu[j],
                               sizeof(szStrMenu[0]),
                               wLangID)) {
        
                sMenuItemInfo.dwTypeData = szStrMenu[j];
                SetMenuItemInfo( hMenu, uIDM + j, FALSE, &sMenuItemInfo);
            }
        }
        
        /* last ID not following the other  */
        if ( loadStringEx( hModule, 
                           IDS_HELP_PLUGIN,
                           szStrMenu[j],
                           sizeof(szStrMenu[0]),
                           wLangID)) {

            sMenuItemInfo.dwTypeData = szStrMenu[j];
            SetMenuItemInfo( hMenu, IDM_HELP_PLUGIN, FALSE, &sMenuItemInfo);
        }



    }
}



/* ------------------------------------------------------------------------- */
void locale_Bdd( HWND          hDlg,           // handle to Bdd
                 HINSTANCE     hModule,        // handle to module ( Dll )
                 WORD          wLangID)        // language identifier
/* ------------------------------------------------------------------------- */
{
    #define         NBR_OF_TEXT 25
    
    static char     szBddText[25][40];
    int             j = 0;


    if ( hDlg == NULL || hModule == NULL)
        return;


    if ( loadStringEx( hModule, IDS_SETUP_MENU, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetWindowText( hDlg, szBddText[j]);
    }
    j++;

    if ( loadStringEx( hModule, IDS_OPTION, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_OPTION, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_MODE, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_MODE, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_CHECK_FULLFIELD, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_CHECK_FULLFIELD, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_RADIO_FCT_AUTO, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_RADIO_FCT_AUTO, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_RADIO_FCT_TT, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_RADIO_FCT_TT, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_RADIO_FCT_TE, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_RADIO_FCT_TE, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_STATIC_PRINCIPE, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_STATIC_PRINCIPE, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_RADIO_DEC_AUTO, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_RADIO_DEC_AUTO, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_CHECK_AZ_START, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_CHECK_AZ_START, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_CHECK_CR_CORP, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_CHECK_CR_CORP, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_CHECK_CR_CORPCOR, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_CHECK_CR_CORPCOR, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_CHECK_DET_AUTO, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_CHECK_DET_AUTO, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_REGLAGE, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_REGLAGE, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_STATIC_OFFSETX, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_STATIC_OFFSETX, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_STATIC_NBRPT, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_STATIC_NBRPT, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_STATIC_LEVEL, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_STATIC_LEVEL, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_STATIC_CORBLACKP, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_STATIC_CORBLACKP, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_STATIC_CORP, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_STATIC_CORP, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_OPTION, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_OPTION, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_STATIC_CORBLACKM, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_STATIC_CORBLACKM, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_STATIC_CORM, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_STATIC_CORM, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_ABOUT, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_ABOUT, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_CANCEL, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_CANCEL, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_DEFAULT, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_DEFAULT, szBddText[j]);
    }
    j++;
		
    if ( loadStringEx( hModule, IDS_OK, szBddText[j],
                       sizeof(szBddText[0]), wLangID)) {
    
        SetDlgItemText( hDlg, IDC_OK, szBddText[j]);
    }
		
}





/* ------------------------------------------------------------------------- */
static int loadStringEx( HINSTANCE  hModule,    // handle to resource module
                         UINT       uID,        // resource identifier
                         LPTSTR     lpBuf,      // resource buffer
                         int        nBufMax,    // size of buffer
                         WORD       wLangID)    // language identifier
/* ------------------------------------------------------------------------- */
/*  Function adapted from MSDN, because LoadString() does not work correctly
    under W95/98 when multiple string tables are used for localisation.
*/
{

    wchar_t       *pwchMem, *pwchCur;
    UINT          uIdRsrcBlk = uID / 16 + 1;
    int           j, nSizeCopy, nStrSizeC, nStrIdx  = uID % 16;
    HRSRC         hResource = NULL;


    if ( (hResource = FindResourceEx( hModule, RT_STRING,
                                      MAKEINTRESOURCE( uIdRsrcBlk),
                                      wLangID)) == NULL
        || (pwchMem = (wchar_t *)LoadResource( hModule, hResource)) == NULL) {

        return( NULL);
    }

    pwchCur = pwchMem;
    
    for ( j = 0; j < 16; j++) {
    
        if ( *pwchCur) {
            
            nStrSizeC = *pwchCur;  // String size in characters.
            pwchCur++;
                  
            if ( j == nStrIdx) {
                // The string has been found in the string table.
                nSizeCopy = nStrSizeC < nBufMax ? nStrSizeC : nBufMax  - 1;
                for ( j = 0; j < nSizeCopy; j++)
                    lpBuf[j] = (char)pwchCur[j];

                lpBuf[nSizeCopy] = '\0';

                return( nSizeCopy);
            }
            pwchCur += nStrSizeC;
        } else {
            pwchCur++;
        }
    }
    return( NULL);

}



 
/* ------------------------------------------------------------------------- */
int loadStringExW( HINSTANCE  hModule,   // handle to resource module
                  UINT       uID,        // resource identifier
                  LPTSTR     lpBuf,      // resource buffer
                  int        nBufMax,    // size of buffer
                  WORD       wLangID     // language identifier
 )
/* ------------------------------------------------------------------------- */
{

    wchar_t       *pwchMem, *pwchCur;
    UINT          uIdRsrcBlk = uID / 16 + 1;
    int           j, nSizeCopy, nStrSizeC, nStrIdx  = uID % 16;
//    HINSTANCE     hModule = NULL;
    HRSRC         hResource = NULL;


    if ( (hResource = FindResourceEx( hModule, RT_STRING,
                                      MAKEINTRESOURCE(uIdRsrcBlk),
//                                    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT)
                                      wLangID)) == NULL
        || (pwchMem = (wchar_t *)LoadResource( hModule, hResource)) == NULL) {

        return( NULL);
    }

    pwchCur = pwchMem;
    
    for ( j = 0; j < 16; j++) {
    
        if ( *pwchCur) {
            
            nStrSizeC = *pwchCur;  // String size in characters.
            pwchCur++;
                  
            if ( j == nStrIdx) {
                // The string has been found in the string table.
                nSizeCopy = ( nStrSizeC < (nBufMax / (int)sizeof(wchar_t)))
                            ? nStrSizeC : (nBufMax  - 1) / sizeof(wchar_t);
                wcsncpy( (wchar_t *)lpBuf, pwchCur, nSizeCopy);
                lpBuf[nSizeCopy * sizeof(wchar_t)] = '\0';

                return( nSizeCopy);
            }
            pwchCur += nStrSizeC;
        } else {
            pwchCur++;
        }
    }
    return( NULL);

} 
