/////////////////////////////////////////////////////////////////////////////
// Misc.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2001 Cricri  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on More FTC & Azertix 9c Those portions are
// Copyright Gloup & Azertix (C) 1999/2000 
//
/////////////////////////////////////////////////////////////////////////////

#include "CriCrack.h"
#include "../../readwriteini/readwriteini.h"

#define	ELS	48

extern QuenotteTV_VideoPlugin	sVP;
extern FTC_CRACK				sCtx;
extern int						ntShift[];
extern int                      ntXposDataBit[];


/* ---------------------- External Functions declaration ------------------- */
inline int dec_cut_lum( YUY_T *const pSrce,
							  const int nPix,
							  const int nStep,
							  const int nLevel);
/* -------------------------------------------------------------------------- */


ConfigINI cfg[] = {
//	parameter				type			variable

	{ "GENERAL"				,CFG_SECTION	, NULL							},

	{ "AUTO_PROCESS_VIDEO"	,CFG_BOOL		,&sVP.AutoProcessVideo			},
	{ "VIA_FIX"				,CFG_BOOL		,&sVP.VIA_FIX					},
	{ "VIA_FIX_X"			,CFG_INT		,&sVP.VIA_FIX_X					},
	{ "OFFSET_X"			,CFG_INT		,&sCtx.nOffsetX					},
	{ "COR_BLEVEL_MINUS"	,CFG_INT		,&sCtx.nCorBlackM				},
	{ "COR_MINUS"			,CFG_INT		,&sCtx.nCorMoins				},
	{ "COR_BLEVEL_PLUS"		,CFG_INT		,&sCtx.nCorBlackP				},
	{ "COR_PLUS"			,CFG_INT		,&sCtx.nCorPlus					},
	{ "NBR_POINT_COREL"		,CFG_INT		,&sCtx.sStatus.nNbrPt			},
	{ "FCT_MODE"			,CFG_INT		,&sCtx.sCmd.eModeFct			},
	{ "FCT_MODE_STR"		,CFG_STRING		,&sCtx.szFct					},
	{ "DEC_MODE"			,CFG_INT		,&sCtx.sCmd.eModeDec			},
	{ "DEC_MODE_STR"		,CFG_STRING		,&sCtx.szDec					},
	{ "AZ_LUM_LEVEL"		,CFG_INT		,&sCtx.nLumLevelAdd				},
	{ "VERSION"				,CFG_STRING		,&sCtx.szVersion				},

	{ "KEYS"				,CFG_SECTION	, NULL							},

	/* planete type	*/
	{ "FTC_P_SEQ"			,CFG_INT		,&sCtx.sKey.sPoly[0].nSeq		},
	{ "FTC_P_NBR_PIC"		,CFG_INT		,&sCtx.sKey.sPoly[0].nNbrFrame	},
	{ "FTC_P_MASK"			,CFG_INT		,&sCtx.sKey.sPoly[0].nMask		},
	{ "FTC_P_KEY"			,CFG_INT		,&sCtx.sKey.sPoly[0].nKey		},
	{ "FTC_P_INC"			,CFG_INT		,&sCtx.sKey.sPoly[0].nStartInc	},
	/* euronews type	*/
	{ "FTC_E_SEQ"			,CFG_INT		,&sCtx.sKey.sPoly[1].nSeq		},
	{ "FTC_E_NBR_PIC"		,CFG_INT		,&sCtx.sKey.sPoly[1].nNbrFrame	},
	{ "FTC_E_MASK"			,CFG_INT		,&sCtx.sKey.sPoly[1].nMask		},
	{ "FTC_E_KEY"			,CFG_INT		,&sCtx.sKey.sPoly[1].nKey		},
	{ "FTC_E_INC"			,CFG_INT		,&sCtx.sKey.sPoly[1].nStartInc	},
	/* canal J type	*/
	{ "FTC_J_SEQ"			,CFG_INT		,&sCtx.sKey.sPoly[2].nSeq		},
	{ "FTC_J_NBR_PIC"		,CFG_INT		,&sCtx.sKey.sPoly[2].nNbrFrame	},
	{ "FTC_J_MASK"			,CFG_INT		,&sCtx.sKey.sPoly[2].nMask		},
	{ "FTC_J_KEY"			,CFG_INT		,&sCtx.sKey.sPoly[2].nKey		},
	{ "FTC_J_INC"			,CFG_INT		,&sCtx.sKey.sPoly[2].nStartInc	},
	/* cine cinema type	*/
	{ "FTC_C_SEQ"			,CFG_INT		,&sCtx.sKey.sPoly[3].nSeq		},
	{ "FTC_C_NBR_PIC"		,CFG_INT		,&sCtx.sKey.sPoly[3].nNbrFrame	},
	{ "FTC_C_MASK"			,CFG_INT		,&sCtx.sKey.sPoly[3].nMask		},
	{ "FTC_C_KEY"			,CFG_INT		,&sCtx.sKey.sPoly[3].nKey		},
	{ "FTC_C_INC"			,CFG_INT		,&sCtx.sKey.sPoly[3].nStartInc	},

	{ NULL, NULL, NULL}
};


char PluginINI[] = "Plugins/CricCrac.ini";



/* -------------------------------------------------------------------------- */
BOOL misc_load_INI( void)
/* -------------------------------------------------------------------------- */
{
	/* return false if file does not exist or if plugin version not equal	*/
	return( ChargerINI( cfg, PluginINI)
			&& !strcmp( CRICRACK_VERSION, sCtx.szVersion));
}



/* -------------------------------------------------------------------------- */
void misc_load_def( void)
/* -------------------------------------------------------------------------- */
{
	sCtx.nOffsetX = 1;
	sCtx.nCorBlackM = 4;
	sCtx.nCorMoins = 2;
	sCtx.nCorBlackP = 5;
	sCtx.nCorPlus = 6;

	sCtx.sStatus.nNbrPt = ntShift[1];

	sCtx.sCmd.eModeDec = DEC_AUTO;
	sCtx.sCmd.eModeFct = FCT_AUTO;
	strcpy( sCtx.szDec, SZ_DEC_AUTO);
	strcpy( sCtx.szFct, SZ_FCT_AUTO);

	sCtx.nLumLevelAdd = 24;

	sVP.VIA_FIX = FALSE;
	sVP.VIA_FIX_X = 768;
	sVP.AutoProcessVideo = TRUE;

	/* key mode infos	*/

	/* planete type	*/
	sCtx.sKey.sPoly[0].nSeq = 0x16;	// 0x19
	sCtx.sKey.sPoly[0].nNbrFrame = 6;
	sCtx.sKey.sPoly[0].nMask = 0x3F;
	sCtx.sKey.sPoly[0].nKey = 0x57A;
	sCtx.sKey.sPoly[0].nStartInc = 0;
	/* euronews type	*/
	sCtx.sKey.sPoly[1].nSeq = 0x4BE; // 0x2F9
	sCtx.sKey.sPoly[1].nNbrFrame = 12;
	sCtx.sKey.sPoly[1].nMask = 0xFFF;
	sCtx.sKey.sPoly[1].nKey = 0x69C;
	sCtx.sKey.sPoly[1].nStartInc = 2;
	/* canal J type	*/
	sCtx.sKey.sPoly[2].nSeq = 0x3E; // 0x3B
	sCtx.sKey.sPoly[2].nNbrFrame = 6;
	sCtx.sKey.sPoly[2].nMask = 0x3F;
	sCtx.sKey.sPoly[2].nKey = 0x7A7;
	sCtx.sKey.sPoly[2].nStartInc = 0;
	/* cine cinema type	*/
	sCtx.sKey.sPoly[3].nSeq = 0x1C; // 0x31
	sCtx.sKey.sPoly[3].nNbrFrame = 6;
	sCtx.sKey.sPoly[3].nMask = 0x3F;
	sCtx.sKey.sPoly[3].nKey = 0x16C;
	sCtx.sKey.sPoly[3].nStartInc = 0;

	strcpy( sCtx.szVersion, CRICRACK_VERSION);
}



/* -------------------------------------------------------------------------- */
BOOL misc_write_INI( void)
/* -------------------------------------------------------------------------- */
{
	SauverINI( cfg, PluginINI);
	return TRUE;
}



/* ------------------------------------------------------------------------- */
bool misc_freeze_frame( void)
/* ------------------------------------------------------------------------- */
{
	short	**pptSrceE, **pptSrceO;
	int		y;

	
	pptSrceE = sVP.EvenLines[sVP.CurrentFrame];
	pptSrceO = sVP.OddLines[sVP.CurrentFrame];
	
	for ( y = 0; y < sCtx.nY; y++) {
		memcpy( &sCtx.wtFrameBufE[y], pptSrceE[y],
				sVP.CurrentX * sizeof(short));
		memcpy( &sCtx.wtFrameBufO[y], pptSrceO[y],
				sVP.CurrentX * sizeof(short));
	}

	return( true);
}



/* ------------------------------------------------------------------------- */
bool misc_copy_frame( const BOOL bIsOdd)
/* ------------------------------------------------------------------------- */
{
	short	**pptDest, *ptSrce;
	int		y, nEndY;

	
	nEndY = sCtx.nY - 2;	// leave 2 last lines for SignalDetecte
	if ( bIsOdd) {
		pptDest = sVP.OddLines[sVP.CurrentFrame];
		ptSrce = sCtx.wtFrameBufO[0];
	} else {
		pptDest = sVP.EvenLines[sVP.CurrentFrame];
		ptSrce = sCtx.wtFrameBufE[0];
	}

	for ( y = 0; y < nEndY; y++) {
		memcpy( pptDest[y], ptSrce + (y * MAXPIXEL),
				sVP.CurrentX * sizeof(short));
	}

	return( true);
}



/* ------------------------------------------------------------------------- */
bool misc_load_frame( void)
/* ------------------------------------------------------------------------- */
{
	static OPENFILENAME	sOfn;
	static char		szFile[260];
	char			szPath[256];
	FILE			*pFh;
	int				y;
	bool			rc = false;


	/*	Init and display Open dialog Box	*/
//	ZeroMemory( &sOfn, sizeof(OPENFILENAME));
	sOfn.lStructSize = sizeof(OPENFILENAME);
	sOfn.hwndOwner = sVP.hwndParent;
	sOfn.lpstrFile = szFile;
	sOfn.nMaxFile = sizeof(szFile);
	sOfn.lpstrFilter = "*.bin";
	sOfn.nFilterIndex = 1;
	sOfn.lpstrFileTitle = NULL;
//	sOfn.lpstrInitialDir = GetCurrentDirectory( sizeof(szFile), (LPTSTR)szFile);
	sOfn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

	if ( sOfn.lpstrInitialDir == NULL) {
		GetCurrentDirectory( sizeof(szPath), szPath);
		sOfn.lpstrInitialDir = szPath;
	} else {
		sOfn.lpstrInitialDir = NULL;
	}

	if ( GetOpenFileName( &sOfn) == TRUE) {
		if ( (pFh = fopen( szFile,"r+b")) == NULL)
			return( false);

		for ( y = 0; y < sCtx.nY; y++) {
			fread( &sCtx.wtFrameBufE[y], sizeof(short), sVP.CurrentX, pFh);
			fread( &sCtx.wtFrameBufO[y], sizeof(short), sVP.CurrentX, pFh);
		}

		fclose( pFh);
		pFh = NULL;
		rc = true;
	}

	return( rc);
}




/* ------------------------------------------------------------------------- */
bool misc_save_frame( void)
/* ------------------------------------------------------------------------- */
{
	FILE	*pFh;
	short	**pptSrceE, **pptSrceO;
	int		y;

	
	if ( (pFh = fopen( "Plugins/frame1.bin","w+b")) == NULL)
		return( false);

	pptSrceE = sVP.EvenLines[sVP.CurrentFrame];
	pptSrceO = sVP.OddLines[sVP.CurrentFrame];
	
	for ( y = 0; y < sCtx.nY; y++) {
		fwrite( pptSrceE[y], sizeof(short), sVP.CurrentX, pFh);
		fwrite( pptSrceO[y], sizeof(short), sVP.CurrentX, pFh);
	}

	fclose( pFh);
	pFh = NULL;

	return( true);
}



/* ------------------------------------------------------------------------- */
void misc_search_blackband( YUY_T *const pSrce, const int y)
/* ------------------------------------------------------------------------- */
{
	static bool		bUpperPart = true;
	static int		rc, nYmin = sCtx.nY >> 2, nYmax = sCtx.nY - nYmin;
	static int		nLevel;


	/* TODO : enhance detection ...	*/

	/* first quarter of the frame	*/
	if ( bUpperPart && y < nYmin) {
		if ( dec_cut_lum( pSrce, 600, 3, sCtx.nLevel + 24) > 0) {
			sCtx.nYmin = y + 1;
			bUpperPart = false;
		}
	/* last quarter of the frame	*/
	} else if ( !bUpperPart && y > nYmax) {
		if ( dec_cut_lum( pSrce, 600, 3, sCtx.nLevel + 16) < 0) {
			sCtx.nYmax = y - 2;
			bUpperPart = true;
		}
	}
}



/* ------------------------------------------------------------------------- */
static void misc_save_infos( int pTab[])
/* ------------------------------------------------------------------------- */
{
	FILE	*pFh;

	
	if ( (pFh = fopen( "Plugins/_OEInfos.txt","a")) == NULL)
		return;

	fprintf( pFh, "\nNew Frame information\n\nO286 ");
	
	for ( int j = 0; j < ELS * 3; j += 3) {
		fprintf( pFh, "%02X ", pTab[j]);
	}
	fprintf( pFh, "\nE287 ");
	for ( j = 1; j < ELS * 3; j += 3) {
		fprintf( pFh, "%02X ", pTab[j]);
	}

	fprintf( pFh, "\nFRME ");
	for ( j = 2; j < ELS * 3; j += 3) {
		fprintf( pFh, "%02X ", pTab[j]);
	}
	fprintf( pFh, "\n");

	fclose( pFh);
	pFh = NULL;

	return;
}



/* ------------------------------------------------------------------------- */
bool misc_IsCodedChannel( YUY_T **const ptLinesOrgE, YUY_T **const ptLinesOrgO,
						const int nFrame)
/* ------------------------------------------------------------------------- */
{
	static int				nCpt, j, nMask, nStartSeq, nSeq, nXmem = 0;
	static bool				bO286, bE287;
	static int				bCC1[ELS][3], nIdx = 0;		// debug purpose
	static u_char			ucE287, ucO286;
	static YUY_T			*pLE287, *pLO286;
	static u_short			wO286;
	static PPOLY_T			pPoly = sCtx.sKey.sPoly;
	static CHANNEL_STATE	*pChannel = &sCtx.sKey.eChannel;


    if ( nXmem != sVP.CurrentX) {
        /* data bits adaptation to the current resolution   */    
        ntXposDataBit[0] = sVP.CurrentX * POS_BIT0 / MAXPIXEL;
        ntXposDataBit[1] = sVP.CurrentX * POS_BIT1 / MAXPIXEL;
        ntXposDataBit[2] = sVP.CurrentX * POS_BIT2 / MAXPIXEL;
        ntXposDataBit[3] = sVP.CurrentX * POS_BIT3 / MAXPIXEL;
        ntXposDataBit[4] = sVP.CurrentX * POS_BIT4 / MAXPIXEL;
        ntXposDataBit[5] = sVP.CurrentX * POS_BIT5 / MAXPIXEL;
        ntXposDataBit[6] = sVP.CurrentX * POS_BIT6 / MAXPIXEL;
        ntXposDataBit[7] = sVP.CurrentX * POS_BIT7 / MAXPIXEL;
        
        nXmem = sVP.CurrentX;
    }

	/* sampling	*/
	pLE287 = ptLinesOrgE[287];
	ucE287 =  (u_char)((pLE287[ntXposDataBit[7]].yX & 0x80)
					| ((pLE287[ntXposDataBit[6]].yX & 0x80) >> 1)
					| ((pLE287[ntXposDataBit[5]].yX & 0x80) >> 2)
					| ((pLE287[ntXposDataBit[4]].yX & 0x80) >> 3)
					| ((pLE287[ntXposDataBit[3]].yX & 0x80) >> 4)
					| ((pLE287[ntXposDataBit[2]].yX & 0x80) >> 5)
					| ((pLE287[ntXposDataBit[1]].yX & 0x80) >> 6)
					| ((pLE287[ntXposDataBit[0]].yX & 0x80) >> 7));

	pLO286 = ptLinesOrgO[286];
	ucO286 =  (u_char)((pLO286[ntXposDataBit[7]].yX & 0x80)
					| ((pLO286[ntXposDataBit[6]].yX & 0x80) >> 1)
					| ((pLO286[ntXposDataBit[5]].yX & 0x80) >> 2)
					| ((pLO286[ntXposDataBit[4]].yX & 0x80) >> 3)
					| ((pLO286[ntXposDataBit[3]].yX & 0x80) >> 4)
					| ((pLO286[ntXposDataBit[2]].yX & 0x80) >> 5)
					| ((pLO286[ntXposDataBit[1]].yX & 0x80) >> 6)
					| ((pLO286[ntXposDataBit[0]].yX & 0x80) >> 7));


	/* detection method	*/
	switch ( *pChannel) {

	case CH_INIT :
		/* used when switching channel to initialize detection	*/
		nSeq = 0;
		nCpt = 0;
		*pChannel = CH_RESEARCH;
		break;

	case CH_RESEARCH :
		
		/* FTC detection	*/
		if ( ((ucE287 & 0x7E) == 0x7E || (ucE287 & 0x7E) == 0x00)
			&& ((ucO286 & 0x7E) == 0x7E || (ucO286 & 0x7E) == 0x00)) {

			bO286 = (ucO286 & 0x7E) == 0x7E;
			bE287 = (ucE287 & 0x7E) == 0x7E;
			
			// shift register
			nSeq = (nSeq << 2) | (u_char)bO286 << 1 | (u_char)bE287;
		
			/* search correct sequence for MAX_FTC_CHANNEL	*/
			for ( j = 0; j < MAX_FTC_CHANNELS; j++) {
				/* to ensure correct sequence, search for 2 sequences	*/
				nMask = pPoly[j].nMask << pPoly[j].nNbrFrame | pPoly[j].nMask;
				nStartSeq = pPoly[j].nSeq << pPoly[j].nNbrFrame | pPoly[j].nSeq;
				if ( (nSeq & nMask) == nStartSeq) {
					/* select correct FTC channel type	*/
					*pChannel = (CHANNEL_STATE)j;
//					sCtx.sKey.bSync = true;
					break;
				}
			}
			if ( j != MAX_FTC_CHANNELS)
				break;
		}

	case CH_CANAL_PLUS_B :

		/* C+B method	*/
		if ( ucE287 == 0x02 || ucE287 == 0x22
			|| ucE287 == 0x03 || ucE287 == 0x23) {

			if ( !(ucE287 & 1)) {
				wO286 = (u_short)(ucO286 << 8);
			} else {
				wO286 |= ucO286;
				// Magic number from Azertix !
				*pChannel = wO286 == 0xBA2 ? CH_CANAL_PLUS_B : CH_INIT;
			}
		}
		break;

	case CH_FTC_P :

	case CH_FTC_E :

	case CH_FTC_J :

	case CH_FTC_C :

		bO286 = (ucO286 & 0x7E) == 0x7E;
		bE287 = (ucE287 & 0x7E) == 0x7E;
		sCtx.sKey.bSync = false;
		nCpt++;

		// shift register
		nSeq = (nSeq << 2) | (u_char)bO286 << 1 | (u_char)bE287;

		/* found correct sequence	*/
		if ((nSeq & pPoly[*pChannel].nMask) == pPoly[*pChannel].nSeq) {
//			||  nCpt % (pPoly[*pChannel].nNbrFrame >> 1) == 0) {
			sCtx.sKey.bSync = true;
			nCpt = 0;
			sCtx.bKeyMode = !sCtx.sCmd.bDisableFtcKey;	// for debug, normally true
		/* too many errors, we leave	*/
		} else if ( nCpt > pPoly[*pChannel].nNbrFrame) {
			*pChannel = CH_INIT;
			sCtx.bKeyMode = false;
		}
		break;

	}


	/* save infos in a file, debug purpose	*/
	if ( sCtx.sCmd.bSaveOEInfos) {

		if ( nIdx >= ELS) {
			nIdx = 0;
			sCtx.sCmd.bSaveOEInfos = false;
			misc_save_infos( &bCC1[0][0]);
		} else {
			bCC1[nIdx][0] = ucO286;
			bCC1[nIdx][1] = ucE287;
			bCC1[nIdx][2] = nFrame;

			nIdx++;
		}

	}

	return( *pChannel < NBR_CRYPTED_CHANNELS);
}



/* ------------------------------------------------------------------------- */
__int64 GetRDTSCTime() 
/* ------------------------------------------------------------------------- */
{
    union {
	  __int64 ll;
	  struct { int lo;int hi ;} s;
	} time;

	__asm
	{
		cpuid
		rdtsc
		mov time.s.lo, eax
		mov time.s.hi, edx
	}

	return time.ll;
}



